<template>
<div class="toolbar-container ml-1 mt-3">
  <div class="btn-group-vertical mr-2 mb-1 edition-toolbar">
    <b-button variant="outline-dark" class="white"
    v-if="selectionService.selectedFeature"
      title="Copier" @click="copyFeature()">
      <b-icon icon="files"/>
    </b-button>
    <b-button variant="outline-dark" class="white"
    v-if="copiedFeature" tooltip title="Coller"
      @click="pasteFeature()">
      <b-icon icon="file-text-fill"/>
    </b-button>
    <b-button :pressed="editionService.activeTool==EditionToolType.ADD_CIRCLE"
      variant="outline-dark" class="white"
      v-if="!layer.geometryType || layer.geometryType=='indéfini'|| layer.geometryType=='polygone'"
      title="Ajouter un cercle" @click="addACircle()">
      <b-icon icon="circle"/>
    </b-button>
    <b-button :pressed="editionService.activeTool==EditionToolType.ADD_POLYGON"
      variant="outline-dark" class="white"
      title="Ajouter un polygone" @click="addAPolygon()"
      v-if="!layer.geometryType || layer.geometryType=='indéfini'|| layer.geometryType=='polygone'"
      ><b-icon icon="bounding-box"/></b-button>
    <b-button :pressed="editionService.activeTool==EditionToolType.ADD_LINE"
      variant="outline-dark" class="white"
      v-if="!layer.geometryType || layer.geometryType=='indéfini'|| layer.geometryType=='ligne'"
      title="Ajouter une ligne" @click="addALine()">
      <b-icon icon="slash"/>
    </b-button>
    <b-button :pressed="editionService.activeTool==EditionToolType.ADD_POINT"
      variant="outline-dark" class="white"
      v-if="!layer.geometryType || layer.geometryType=='indéfini'|| layer.geometryType=='point'"
      title="Ajouter un point" @click="addAPoint()">
      <b-icon icon="geo"/>
    </b-button>
    <b-button :pressed="editionService.activeTool==EditionToolType.UPDATE_SHAPE"
      variant="outline-dark" class="white"
      title="Modifier la géométrie" @click="updateShape()">
      <b-icon icon="pencil-square"/>
    </b-button>
    <b-button :pressed="editionService.activeTool==EditionToolType.MOVE_SHAPE"
      variant="outline-dark" class="white"
      title="déplacer la géométrie" @click="moveShape()">
      <b-icon icon="arrows-move"/>
    </b-button>
    <b-button :pressed="editionService.activeTool==EditionToolType.DELETE"
      variant="outline-dark" class="white"
      title="Supprimer" @click="deleteFeature()">
      <b-icon icon="trash"/>
    </b-button>
  </div>
</div>
</template>

<script lang="ts">
/* eslint-disable no-underscore-dangle */
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import EditionToolType from '@/models/map-context/EditionToolType';
import LayerConfig from '@/models/map-context/LayerConfig';
import CesiumSelectionService from '@/services/CesiumSelectionService';
import EditionService from '@/services/EditionService';
import { EventBus, EVENTS } from '@/services/EventBus';
import { MapService } from '@/services/MapService';
import SelectionService from '@/services/SelectionService';
import { Feature } from 'ol';
import Polygon from 'ol/geom/Polygon';
import Component from 'vue-class-component';
import BaseComponent from '../BaseComponent';

@Component({
  props: {
    layer: LayerConfig,
  },
})
export default class EditionToolBar extends BaseComponent {
  public EditionToolType = EditionToolType;

  copiedFeature:any = null;

  selectionService!:SelectionService| CesiumSelectionService;

  editionService!:EditionService;

  layer!:LayerConfig;

  data() {
    return {
      selectionService: undefined,
      editionService: undefined,
    };
  }

  created() {
    this.selectionService = this.getMapService().selectionService;
    const mapService = this.getMapService();
    if (mapService instanceof MapService) {
      this.editionService = mapService.editionService;
    }
  }

  beforeDestroy() {
    this.editionService.reset();
  }

  copyFeature() {
    const toCopy = this.selectionService.selectedFeature[0];
    if (toCopy instanceof Feature) {
      this.copiedFeature = this.selectionService.selectedFeature[0].clone();
    } else {
      const geom = new Polygon(toCopy.flatCoordinates_, 'XY',
        this.selectionService.selectedFeature[0].ends_);
      const feature = new Feature({
        geometry: geom,
        name: 'Copied Polygon',
      });
      this.copiedFeature = feature;
    }
  }

  isActive(tool:string) :boolean {
    return this.editionService.activeTool === tool;
  }

  pasteFeature() {
    console.log(this.copiedFeature);
    this.layer.getLayerSource().addFeature(this.copiedFeature);
    this.editionService.save(this.layer);
  }

  public addAPolygon(): void {
    this.clickTool(EditionToolType.ADD_POLYGON);
  }

  public addALine(): void {
    this.clickTool(EditionToolType.ADD_LINE);
  }

  public addAPoint(): void {
    this.clickTool(EditionToolType.ADD_POINT);
  }

  public addACircle(): void {
    this.clickTool(EditionToolType.ADD_CIRCLE);
  }

  public clickTool(tool:string) {
    console.log('clickTool', tool);
    // if current active tool is not this one
    if (this.editionService.activeTool !== tool) {
      this.editionService.reset();
      switch (tool) {
        case EditionToolType.UPDATE_SHAPE:
          this.editionService.updateShape(this.layer);
          break;
        case EditionToolType.MOVE_SHAPE:
          this.editionService.moveShape(this.layer);
          break;
        case EditionToolType.DELETE:
          this.editionService.delete(this.layer);
          break;
        case EditionToolType.ADD_POLYGON:
        case EditionToolType.ADD_POINT:
        case EditionToolType.ADD_LINE:
        case EditionToolType.ADD_CIRCLE:
          this.editionService.activeEdition(tool, this.layer);
          break;
        default:
          break;
      }
    } else {
      this.editionService.reset();
    }
  }

  public updateShape(): void {
    this.clickTool(EditionToolType.UPDATE_SHAPE);
  }

  public moveShape(): void {
    this.clickTool(EditionToolType.MOVE_SHAPE);
  }

  public deleteFeature(): void {
    this.clickTool(EditionToolType.DELETE);
  }
}
</script>

<style scoped lang="less">
.toolbar-container{
  pointer-events: auto;
}
</style>
